import { createMethodRecord } from '@modular-component/core';
const withConditionalFallback = Symbol();
const withConditionalRender = Symbol();
export const WithConditionalRender = createMethodRecord({
    withCondition: {
        field: 'condition',
        multiple: true,
        transform: (args, useCondition) => args.condition !== false &&
            (typeof useCondition === 'function' ? useCondition(args) : useCondition),
        restrict: {},
    },
    withConditionalFallback: {
        field: 'render',
        multiple: true,
        symbol: withConditionalFallback,
        transform: (args, useRender) => {
            if (args.condition !== false || args.render) {
                return args.render;
            }
            return typeof useRender === 'function' ? useRender(args) : useRender;
        },
        restrict: {},
    },
    withConditionalRender: {
        field: 'render',
        symbol: withConditionalRender,
        transform: (args, useRender) => {
            if (args.condition === false) {
                return args.render;
            }
            return typeof useRender === 'function' ? useRender(args) : useRender;
        },
        restrict: {},
    },
});
//# sourceMappingURL=index.js.map